com.thinkaurelius.titan.graphdb.database

## Class IndexSerializer

- java.lang.Object
- - com.thinkaurelius.titan.graphdb.database.IndexSerializer

-     public class IndexSerializer
      extends Object

  Author:
    Matthias Broecheler (me@matthiasb.com)

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `IndexSerializer.IndexInfoRetriever`
    `static class` | `IndexSerializer.IndexRecords`
    `static class` | `IndexSerializer.IndexUpdate<K,E>`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IndexSerializer(Serializer serializer, Map<String,? extends IndexInformation> indexes, boolean hashKeys)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `containsIndex(String indexName)`
    `Iterable<RawQuery.Result>` | `executeQuery(IndexQueryBuilder query, ElementCategory resultType, BackendTransaction backendTx, StandardTitanTx transaction)`
    `IndexSerializer.IndexInfoRetriever` | `getIndexInfoRetriever(StandardTitanTx tx)`
    `Collection<IndexSerializer.IndexUpdate>` | `getIndexUpdates(InternalRelation relation)`
    `Collection<IndexSerializer.IndexUpdate>` | `getIndexUpdates(InternalVertex vertex, Collection<InternalRelation> updatedProperties)`
    `KeySliceQuery` | `getQuery(CompositeIndexType index, Object[] values)`
    `IndexQuery` | `getQuery(MixedIndexType index, Condition condition, OrderList orders)`
    `static com.thinkaurelius.titan.graphdb.database.IndexSerializer.RecordEntry[]` | `indexMatch(TitanRelation relation, CompositeIndexType index)`
    `static IndexSerializer.IndexRecords` | `indexMatches(TitanVertex vertex, CompositeIndexType index)`
    `static IndexSerializer.IndexRecords` | `indexMatches(TitanVertex vertex, CompositeIndexType index, PropertyKey replaceKey, Object replaceValue)`
    `List<Object>` | `query(JointIndexQuery.Subquery query, BackendTransaction tx)`
    `static void` | `register(MixedIndexType index, PropertyKey key, BackendTransaction tx)`
    `Set<IndexSerializer.IndexUpdate<StaticBuffer,Entry>>` | `reindexElement(TitanElement element, CompositeIndexType index)`
    `void` | `reindexElement(TitanElement element, MixedIndexType index, Map<String,Map<String,List<IndexEntry>>> documentsPerStore)`
    `void` | `removeElement(Object elementId, MixedIndexType index, Map<String,Map<String,List<IndexEntry>>> documentsPerStore)`
    `boolean` | `supports(MixedIndexType index, ParameterIndexField field, TitanPredicate predicate)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IndexSerializer

          public IndexSerializer(Serializer serializer,
                         Map<String,? extends IndexInformation> indexes,
                         boolean hashKeys)

  - ### Method Detail

    - #### containsIndex

          public boolean containsIndex(String indexName)

    - #### register

          public static void register(MixedIndexType index,
                      PropertyKey key,
                      BackendTransaction tx)
                               throws BackendException

      Throws:
        `BackendException`

    - #### supports

          public boolean supports(MixedIndexType index,
                         ParameterIndexField field,
                         TitanPredicate predicate)

    - #### getIndexInfoRetriever

          public IndexSerializer.IndexInfoRetriever getIndexInfoRetriever(StandardTitanTx tx)

    - #### getIndexUpdates

          public Collection<IndexSerializer.IndexUpdate> getIndexUpdates(InternalRelation relation)

    - #### getIndexUpdates

          public Collection<IndexSerializer.IndexUpdate> getIndexUpdates(InternalVertex vertex,
                                                                Collection<InternalRelation> updatedProperties)

    - #### reindexElement

          public void reindexElement(TitanElement element,
                            MixedIndexType index,
                            Map<String,Map<String,List<IndexEntry>>> documentsPerStore)

    - #### removeElement

          public void removeElement(Object elementId,
                           MixedIndexType index,
                           Map<String,Map<String,List<IndexEntry>>> documentsPerStore)

    - #### reindexElement

          public Set<IndexSerializer.IndexUpdate<StaticBuffer,Entry>> reindexElement(TitanElement element,
                                                                            CompositeIndexType index)

    - #### indexMatch

          public static com.thinkaurelius.titan.graphdb.database.IndexSerializer.RecordEntry[] indexMatch(TitanRelation relation,
                                                                                          CompositeIndexType index)

    - #### indexMatches

          public static IndexSerializer.IndexRecords indexMatches(TitanVertex vertex,
                                                  CompositeIndexType index)

    - #### indexMatches

          public static IndexSerializer.IndexRecords indexMatches(TitanVertex vertex,
                                                  CompositeIndexType index,
                                                  PropertyKey replaceKey,
                                                  Object replaceValue)

    - #### query

          public List<Object> query(JointIndexQuery.Subquery query,
                           BackendTransaction tx)

    - #### getQuery

          public KeySliceQuery getQuery(CompositeIndexType index,
                               Object[] values)

    - #### getQuery

          public IndexQuery getQuery(MixedIndexType index,
                            Condition condition,
                            OrderList orders)

    - #### executeQuery

          public Iterable<RawQuery.Result> executeQuery(IndexQueryBuilder query,
                                               ElementCategory resultType,
                                               BackendTransaction backendTx,
                                               StandardTitanTx transaction)

Copyright © 2012–2014. All rights reserved.